$regfile = "m162def.dat"
$prog &HFF , &HEF , &HD9 , &HFB       ' generated. Take care that the chip supports all fuse bytes.
$crystal = 12000000
$baud = 19200
Config Lcd = 20 * 4
Config Portc = Output
Portc = 0
Config Porta = Input
Porta = &B11111000
Config Portd = Output
Portd = 0
Config Sda = Portd.5
Config Scl = Portd.4
Config I2cdelay = 2
Config Timer0 = Timer , Prescale = 64
Enable Interrupts
Enable Timer0            'zaczane programowo zeby ykona ruch- wyczane podczas odbioru danych itp.
On Timer0 Co10us
 Enabx Alias Portc.2
 Enaby Alias Portc.4
 Enabz Alias Portc.6
 Clock Alias Portc.0
Clock2 Alias Portd.7
  Dirx Alias Portc.1
  Diry Alias Portc.3
  Dirz Alias Portc.5
 Czujx Alias Porta.0
 Czujy Alias Porta.1
 Czujz Alias Porta.2
    P1 Alias Porta.3
    P2 Alias Porta.4
    P3 Alias Porta.5
    P4 Alias Porta.6
    P5 Alias Porta.7
Wrzeciono Alias Portc.7
Deflcdchar 1 , 2 , 4 , 31 , 2 , 4 , 8 , 31 , 32
Deflcdchar 0 , 2 , 4 , 14 , 17 , 17 , 17 , 14 , 32
Deflcdchar 2 , 12 , 5 , 6 , 12 , 20 , 4 , 14 , 32
Declare Sub Powitanie
Declare Sub Menu_glowne
Declare Sub Odbior_danych       'procedura odbioru danych z PC- zapis do EEPROM
Declare Sub Automat      ' procedura pracy automatycznej
Declare Sub Ruch_xyz
Declare Sub Zap_eeprom(byval Adres As Word , Byval Dana As Byte)       'procedura zapisu danej do pamieci
Declare Sub Odc_eeprom(byval Adres As Word , Dana As Byte)       'procedura odczytu danej z pamieci
Const Adr_w = 160        'adres zapisu danej do pamieci EEPROM
Const Adr_r = 161        'adres odczytu danej do pamieci EEPROM
Dim Pom1 As Byte         'okrela czstot. przebiegu
Dim B1 As Byte           'modszy bajt ruchu odczytany z EEPROM
Dim B2 As Byte           'starszy bajt ruchu odczytany z EEPROM
Dim Value As Byte
Dim Adres As Word        'zmienna adresu komorki pamieci
Dim Adr_h As Byte        'bardziej znaczaca polowka adresu
Dim Adr_l As Byte        'mniej znaczaca polowka adresu
Dim Dana As Byte         'zmienna zmienna na odczytana lub zapisana dana do pamieci
Dim Inf As Bit           ' jesli 1 to odczytany bajt jest informacyjnym
Dim X As Bit             'jeli 1- to ruch dotyczy osi x
Dim Y As Bit             'jeli 1 to ruch dotyczy osi Y
Dim Sx As Bit            '1- dwa bajty dla ruchu X 0- jeden bajt dla tuchu X
Dim Sy As Bit            '1- dwa bajty dla ruchu Y 0- jeden bajt dla tuchu Y
Dim Endd As Bit          'ostatni bajt
Dim Stepx As Integer     'iloc krokw do wykonania w osi X
Dim Stepy As Integer     'iloc krokw do wykonania w osi X
Dim I As Integer         'I=Stepx- wrzeciono osigneo pozycj X
Dim J As Integer         'J=StepY- wrzeciono osigneo pozycj Y
Dim K As Integer
Adres = 0
Cursor Off
Powitanie
Menu_glowne

Do

Loop



Co10us:                  'obsuga przerwania przychodzcego od Timer0- gene
Timer0 = 254             'ruje fale prostoktn- sygna CLK
If Clock = 0 Then
   Toggle Clock
   Clock2 = Not Clock
   Incr I
   Incr J
 Else
   Incr Pom1
   If Pom1 = 95 Then
      Pom1 = 0
       Toggle Clock
       Clock2 = Not Clock
   End If
End If
Return



Sub Powitanie
Cursor Off
Cls
Lcd "**" : Locate 4 , 19 : Lcd "**" : Locate 1 , 3
Waitms 2
Lcd "**" : Locate 4 , 17 : Lcd "**" : Locate 1 , 5
Waitms 2
Lcd "**" : Locate 4 , 15 : Lcd "**" : Locate 1 , 7
Waitms 2
Lcd "**" : Locate 4 , 13 : Lcd "**" : Locate 1 , 9
Waitms 2
Lcd "**" : Locate 4 , 11 : Lcd "**" : Locate 1 , 11
Waitms 2
Lcd "**" : Locate 4 , 9 : Lcd "**" : Locate 1 , 13
Waitms 2
Lcd "**" : Locate 4 , 7 : Lcd "**" : Locate 1 , 15
Waitms 2
Lcd "**" : Locate 4 , 5 : Lcd "**" : Locate 1 , 17
Waitms 2
Lcd "**" : Locate 4 , 3 : Lcd "**" : Locate 1 , 19
Waitms 2
Lcd "**" : Locate 4 , 1 : Lcd "**" : Locate 3 , 1
Waitms 2
Lcd "*" : Locate 2 , 20 : Lcd "*" : Locate 2 , 1
Waitms 2
Lcd "*" : Locate 3 , 20 : Lcd "*" : Locate 2 , 2
Waitms 2
Lcd "PCB driver Ver.1.0"
Locate 3 , 2
Lcd " Wykona" ; Chr(2) ; " J.Gw" ; Chr(0) ; Chr(1) ; "d" ; Chr(1)
Waitms 200
Cls
End Sub

Sub Menu_glowne
  Cls
  Lcd " Wybierz tryb pracy"
  Locate 2 , 1
  Lcd "1-odbior danych"
  Locate 3 , 1
  Lcd "2-Automat"
  Locate 4 , 1
  Lcd "3-Reczny"
End Sub


Sub Odbior_danych        'chyba za kaym razwe powinno si wyzerowa dane typu adres I, J- ???
Disable Interrupts
Cls
Lcd "Tryb odbioru danych"
Thirdline
Lcd "    Bajt" ; Chr(0) ; "w:"
Do
 Input Dana
 Call Zap_eeprom(adres , Dana)
 Locate 3 , 12
 Lcd Adres               'konieczne wprowadzenie sygnalizacji czy odbr jest realizowany
 Incr Adres
 If Dana.0 = 1 And Dana.7 = 1 Then Exit Do       ' zle- if... to pobierz jeszcze 2 bajty
Loop
Adres = 0                ' wyzerowa zmienn wskazujc na komrke pamici- wywoanie odczytu EEPROMa musi by od ) komrki
Cls
Lcd "     Transmisja" : Locate 2 , 6 : Lcd "zakonczona"
Wait 1
Call Menu_glowne
End Sub


Sub Zap_eeprom(byval Adres As Word , Byval Dana As Byte)       'procedura zapisu danej do EEPROM
  Adr_h = High(adres)    'zapis do Adr_h bardziej znaczacej polowki adresu
  Adr_l = Low(adres)     'zapis do Adr_l mniej znaczacej polowki adresu
  I2cstart               'start transmisji
  I2cwbyte Adr_w         'zapis adresu ukladu pamieci do zapisu
  I2cwbyte Adr_h         'bardziej znaczacy adres komorki pamieci
  I2cwbyte Adr_l         'mniej znaczacy adres komorki pamieci
  I2cwbyte Dana          'zapis danej
  I2cstop                'koniec transmisji
  Waitms 7               'opoznienie 7 ms
End Sub                  'koniec procedury

Sub Odc_eeprom(byval Adres As Word , Dana As Byte)       'procedura odczytu danej do EEPROM
  Adr_h = High(adres)    'zapis do Adr_h bardziej znaczacej polowki adresu
  Adr_l = Low(adres)     'zapis do Adr_l mniej znaczacej polowki adresu
  I2cstart               'start transmisji
  I2cwbyte Adr_w         'zapis adresu ukladu pamieci do zapisu
  I2cwbyte Adr_h         'bardziej znaczacy adres komorki pamieci
  I2cwbyte Adr_l         'mniej znaczacy adres komorki pamieci
  I2cstart               'ponowny start transmisji
  I2cwbyte Adr_r         'zapis adresu ukladu pamieci do odczytu
  I2crbyte Dana , Nack   'odczyt bajta danej - bez potwierdzenia sygnaem ACK
  I2cstop                'koniec transmisji
End Sub

Sub Automat
                     'sprawdz pooenie gowicy w obu osiach- jeli nie na punkcie bazowym to dojed
 Do
  Disable Interrupts     'zablokuj przerwania- pobieranie i dekodowanie danych
  Call Odc_eeprom(adres , Dana)
  Incr Adres             'zwiksz zminn- cztaj z kolejnej komrki
  If Dana.0 = 1 Then     ' jesli bajt jest informacyjny
    Dirx = Not Dana.1    'ustwa kierunek  X
    Diry = Not Dana.2    'ustwa kierunek Y
    X = Dana.3           '1- ruch w osi
    Y = Dana.4           '1- ruch w osi
    Sx = Dana.6          'ile bajtw pobra?
    Sy = Dana.5
    Endd = Dana.7
  Else                   'jeli 1 bajt nie jest informacyjny
    Cls
    Lcd "Bd"
  End If
  If X = 0 Then          'jesli ruch w X nie jest wykonywany
    Stepx = 0            ' to iloc krokw jest 0
    Enabx = 0
  Else                   'w przeciwnym wypadku
    Enabx = 1
    If Sx = 0 Then       'jeli ruch jest zapisany w jednym bajcie
      Call Odc_eeprom(adres , Dana)       ' to odczytaj ten bajt
      Incr Adres
      Stepx = Dana       'i przypisz go do iloci krokw w X
    Else                 'jeeli w 2 bajtach zapisano ruch
      Call Odc_eeprom(adres , Dana)
      Incr Adres
      B1 = Dana
      Call Odc_eeprom(adres , Dana)
      Incr Adres
      B2 = Dana
      Stepx = Makeint(b1 , B2)       'tutaj trzeba scali 2 bajty w jeden operacja przeciwna do Low i High
      Cls
    End If
  End If
  If Y = 0 Then          'jesli ruch w Y nie jest wykonywany
    Stepy = 0            ' to iloc krokw jest 0
    Enaby = 0
  Else                   'w przeciwnym wypadku
    Enaby = 1
    If Sy = 0 Then       'jeli ruch jest zapisany w jednym bajcie
      Call Odc_eeprom(adres , Dana)       ' to odczytaj ten bajt
      Incr Adres
      Stepy = Dana       'i przypisz go do iloci krokw w Y
    Else                 'jeeli w 2 bajtach zapisano ruch
      Call Odc_eeprom(adres , Dana)
      Incr Adres
      B1 = Dana
      Call Odc_eeprom(adres , Dana)
      Incr Adres
      B2 = Dana
      Stepy = Makeint(b1 , B2)       'tutaj trzeba scali 2 bajty w jeden operacja przeciwna do Low i High
    End If
  End If
  Ruch_xyz
  If Endd = 1 Then Exit Do
 Loop
End Sub
Return

Sub Ruch_xyz
 I = 0
 J = 0
 Enable Interrupts
 While I < Stepx And J < Stepy
 Wend
 While I < Stepx
 Wend
 Enabx = 0
 While J < Stepy
 Wend
 Enaby = 0
 'wiercimy
End Sub


